testautomation_main.c File Reference
`#include "SDL.h"`
`#include "SDL_test.h"`
Include dependency graph for testautomation_main.c:

Go to the source code of this file.

## Functions

static int | main_testInitQuitJoystickHaptic (void *arg)
static int | main_testInitQuitSubSystem (void *arg)
static int | main_testImpliedJoystickInit (void *arg)
static int | main_testImpliedJoystickQuit (void *arg)

## Variables

const int | joy_and_controller = SDL_INIT_JOYSTICK | SDL_INIT_GAMECONTROLLER
static const SDLTest_TestCaseReference | mainTest1
static const SDLTest_TestCaseReference | mainTest2
static const SDLTest_TestCaseReference | mainTest3
static const SDLTest_TestCaseReference | mainTest4
static const SDLTest_TestCaseReference * | mainTests []
SDLTest_TestSuiteReference | mainTestSuite

## Function Documentation

static int main_testImpliedJoystickInit | ( | void * | arg | ) |

static

Definition at line 75 of file testautomation_main.c.

References joy_and_controller, SDL_INIT_GAMECONTROLLER, SDL_InitSubSystem, SDL_QuitSubSystem, SDL_WasInit, SDLTest_AssertCheck(), TEST_COMPLETED, and TEST_SKIPPED.

{
#if defined SDL_JOYSTICK_DISABLED || defined SDL_GAMECONTROLLER_DISABLED
return TEST_SKIPPED;
#else
int initialized_system;
/* First initialize the controller */
SDLTest_AssertCheck( (SDL_WasInit(joy_and_controller) & joy_and_controller) == 0, "SDL_WasInit() before init should be false for joystick & controller" );
SDLTest_AssertCheck( SDL_InitSubSystem(SDL_INIT_GAMECONTROLLER) == 0, "SDL_InitSubSystem(SDL_INIT_GAMECONTROLLER)" );
/* Then make sure this implicitly initialized the joystick subsystem */
initialized_system = SDL_WasInit(joy_and_controller);
SDLTest_AssertCheck( (initialized_system & joy_and_controller) == joy_and_controller, "SDL_WasInit() should be true for joystick & controller (%x)", initialized_system );
/* Then quit the controller, and make sure that implicitly also quits the */
/* joystick subsystem */
SDL_QuitSubSystem(SDL_INIT_GAMECONTROLLER);
initialized_system = SDL_WasInit(joy_and_controller);
SDLTest_AssertCheck( (initialized_system & joy_and_controller) == 0, "SDL_WasInit() should be false for joystick & controller (%x)", initialized_system );
return TEST_COMPLETED;
#endif
}
SDL_QuitSubSystem
#define SDL_QuitSubSystem
Definition: SDL_dynapi_overrides.h:62
joy_and_controller
const int joy_and_controller
Definition: testautomation_main.c:74
SDL_InitSubSystem
#define SDL_InitSubSystem
Definition: SDL_dynapi_overrides.h:61
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
TEST_COMPLETED
#define TEST_COMPLETED
Definition: SDL_test_harness.h:53
SDL_INIT_GAMECONTROLLER
#define SDL_INIT_GAMECONTROLLER
Definition: SDL.h:80
SDL_WasInit
#define SDL_WasInit
Definition: SDL_dynapi_overrides.h:63
TEST_SKIPPED
#define TEST_SKIPPED
Definition: SDL_test_harness.h:54

static int main_testImpliedJoystickQuit | ( | void * | arg | ) |

static

Definition at line 100 of file testautomation_main.c.

References joy_and_controller, SDL_INIT_GAMECONTROLLER, SDL_INIT_JOYSTICK, SDL_InitSubSystem, SDL_QuitSubSystem, SDL_WasInit, SDLTest_AssertCheck(), TEST_COMPLETED, and TEST_SKIPPED.

{
#if defined SDL_JOYSTICK_DISABLED || defined SDL_GAMECONTROLLER_DISABLED
return TEST_SKIPPED;
#else
int initialized_system;
/* First initialize the controller and the joystick (explicitly) */
SDLTest_AssertCheck( (SDL_WasInit(joy_and_controller) & joy_and_controller) == 0, "SDL_WasInit() before init should be false for joystick & controller" );
SDLTest_AssertCheck( SDL_InitSubSystem(SDL_INIT_JOYSTICK) == 0, "SDL_InitSubSystem(SDL_INIT_JOYSTICK)" );
SDLTest_AssertCheck( SDL_InitSubSystem(SDL_INIT_GAMECONTROLLER) == 0, "SDL_InitSubSystem(SDL_INIT_GAMECONTROLLER)" );
/* Then make sure they're both initialized properly */
initialized_system = SDL_WasInit(joy_and_controller);
SDLTest_AssertCheck( (initialized_system & joy_and_controller) == joy_and_controller, "SDL_WasInit() should be true for joystick & controller (%x)", initialized_system );
/* Then quit the controller, and make sure that it does NOT quit the */
/* explicitly initialized joystick subsystem. */
SDL_QuitSubSystem(SDL_INIT_GAMECONTROLLER);
initialized_system = SDL_WasInit(joy_and_controller);
SDLTest_AssertCheck( (initialized_system & joy_and_controller) == SDL_INIT_JOYSTICK, "SDL_WasInit() should be false for joystick & controller (%x)", initialized_system );
SDL_QuitSubSystem(SDL_INIT_JOYSTICK);
return TEST_COMPLETED;
#endif
}
SDL_INIT_JOYSTICK
#define SDL_INIT_JOYSTICK
Definition: SDL.h:78
SDL_QuitSubSystem
#define SDL_QuitSubSystem
Definition: SDL_dynapi_overrides.h:62
joy_and_controller
const int joy_and_controller
Definition: testautomation_main.c:74
SDL_InitSubSystem
#define SDL_InitSubSystem
Definition: SDL_dynapi_overrides.h:61
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
TEST_COMPLETED
#define TEST_COMPLETED
Definition: SDL_test_harness.h:53
SDL_INIT_GAMECONTROLLER
#define SDL_INIT_GAMECONTROLLER
Definition: SDL.h:80
SDL_WasInit
#define SDL_WasInit
Definition: SDL_dynapi_overrides.h:63
TEST_SKIPPED
#define TEST_SKIPPED
Definition: SDL_test_harness.h:54

static int main_testInitQuitJoystickHaptic | ( | void * | arg | ) |

static

Automated SDL subsystems management test.

Written by J�rgen Tjern� "jorgenpt"

Released under Public Domain.

Definition at line 19 of file testautomation_main.c.

References SDL_Init, SDL_INIT_HAPTIC, SDL_INIT_JOYSTICK, SDL_Quit, SDL_WasInit, SDLTest_AssertCheck(), TEST_COMPLETED, and TEST_SKIPPED.

{
#if defined SDL_JOYSTICK_DISABLED || defined SDL_HAPTIC_DISABLED
return TEST_SKIPPED;
#else
int enabled_subsystems;
int initialized_subsystems = SDL_INIT_JOYSTICK | SDL_INIT_HAPTIC;
SDLTest_AssertCheck( SDL_Init(initialized_subsystems) == 0, "SDL_Init multiple systems." );
enabled_subsystems = SDL_WasInit(initialized_subsystems);
SDLTest_AssertCheck( enabled_subsystems == initialized_subsystems, "SDL_WasInit(SDL_INIT_EVERYTHING) contains all systems (%i)", enabled_subsystems );
SDL_Quit();
enabled_subsystems = SDL_WasInit(initialized_subsystems);
SDLTest_AssertCheck( enabled_subsystems == 0, "SDL_Quit should shut down everything (%i)", enabled_subsystems );
return TEST_COMPLETED;
#endif
}
SDL_INIT_JOYSTICK
#define SDL_INIT_JOYSTICK
Definition: SDL.h:78
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
SDL_Quit
#define SDL_Quit
Definition: SDL_dynapi_overrides.h:64
TEST_COMPLETED
#define TEST_COMPLETED
Definition: SDL_test_harness.h:53
SDL_Init
#define SDL_Init
Definition: SDL_dynapi_overrides.h:60
SDL_WasInit
#define SDL_WasInit
Definition: SDL_dynapi_overrides.h:63
SDL_INIT_HAPTIC
#define SDL_INIT_HAPTIC
Definition: SDL.h:79
TEST_SKIPPED
#define TEST_SKIPPED
Definition: SDL_test_harness.h:54

static int main_testInitQuitSubSystem | ( | void * | arg | ) |

static

Definition at line 47 of file testautomation_main.c.

References i, SDL_arraysize, SDL_INIT_GAMECONTROLLER, SDL_INIT_HAPTIC, SDL_INIT_JOYSTICK, SDL_InitSubSystem, SDL_QuitSubSystem, SDL_WasInit, SDLTest_AssertCheck(), TEST_COMPLETED, and TEST_SKIPPED.

{
#if defined SDL_JOYSTICK_DISABLED || defined SDL_HAPTIC_DISABLED || defined SDL_GAMECONTROLLER_DISABLED
return TEST_SKIPPED;
#else
int i;
int subsystems[] = { SDL_INIT_JOYSTICK, SDL_INIT_HAPTIC, SDL_INIT_GAMECONTROLLER };
for (i = 0; i < SDL_arraysize(subsystems); ++i) {
int initialized_system;
int subsystem = subsystems[i];
SDLTest_AssertCheck( (SDL_WasInit(subsystem) & subsystem) == 0, "SDL_WasInit(%x) before init should be false", subsystem );
SDLTest_AssertCheck( SDL_InitSubSystem(subsystem) == 0, "SDL_InitSubSystem(%x)", subsystem );
initialized_system = SDL_WasInit(subsystem);
SDLTest_AssertCheck( (initialized_system & subsystem) != 0, "SDL_WasInit(%x) should be true (%x)", subsystem, initialized_system );
SDL_QuitSubSystem(subsystem);
SDLTest_AssertCheck( (SDL_WasInit(subsystem) & subsystem) == 0, "SDL_WasInit(%x) after shutdown should be false", subsystem );
}
return TEST_COMPLETED;
#endif
}
SDL_INIT_JOYSTICK
#define SDL_INIT_JOYSTICK
Definition: SDL.h:78
SDL_QuitSubSystem
#define SDL_QuitSubSystem
Definition: SDL_dynapi_overrides.h:62
SDL_InitSubSystem
#define SDL_InitSubSystem
Definition: SDL_dynapi_overrides.h:61
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
TEST_COMPLETED
#define TEST_COMPLETED
Definition: SDL_test_harness.h:53
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:42
SDL_arraysize
#define SDL_arraysize(array)
Definition: SDL_stdinc.h:93
SDL_INIT_GAMECONTROLLER
#define SDL_INIT_GAMECONTROLLER
Definition: SDL.h:80
SDL_WasInit
#define SDL_WasInit
Definition: SDL_dynapi_overrides.h:63
SDL_INIT_HAPTIC
#define SDL_INIT_HAPTIC
Definition: SDL.h:79
TEST_SKIPPED
#define TEST_SKIPPED
Definition: SDL_test_harness.h:54

## Variable Documentation

const int joy_and_controller = SDL_INIT_JOYSTICK | SDL_INIT_GAMECONTROLLER

Definition at line 74 of file testautomation_main.c.

Referenced by main_testImpliedJoystickInit(), and main_testImpliedJoystickQuit().

const SDLTest_TestCaseReference mainTest1

static

Initial value:
=
{ (SDLTest_TestCaseFp)main_testInitQuitJoystickHaptic, "main_testInitQuitJoystickHaptic", "Tests SDL_Init/Quit of Joystick and Haptic subsystem", TEST_ENABLED}
main_testInitQuitJoystickHaptic
static int main_testInitQuitJoystickHaptic(void *arg)
Definition: testautomation_main.c:19
SDLTest_TestCaseFp
int(* SDLTest_TestCaseFp)(void *arg)
Definition: SDL_test_harness.h:67
TEST_ENABLED
#define TEST_ENABLED
Definition: SDL_test_harness.h:47

Definition at line 128 of file testautomation_main.c.

const SDLTest_TestCaseReference mainTest2

static

Initial value:
=
{ (SDLTest_TestCaseFp)main_testInitQuitSubSystem, "main_testInitQuitSubSystem", "Tests SDL_InitSubSystem/QuitSubSystem", TEST_ENABLED}
main_testInitQuitSubSystem
static int main_testInitQuitSubSystem(void *arg)
Definition: testautomation_main.c:47
SDLTest_TestCaseFp
int(* SDLTest_TestCaseFp)(void *arg)
Definition: SDL_test_harness.h:67
TEST_ENABLED
#define TEST_ENABLED
Definition: SDL_test_harness.h:47

Definition at line 131 of file testautomation_main.c.

const SDLTest_TestCaseReference mainTest3

static

Initial value:
=
{ (SDLTest_TestCaseFp)main_testImpliedJoystickInit, "main_testImpliedJoystickInit", "Tests that init for gamecontroller properly implies joystick", TEST_ENABLED}
SDLTest_TestCaseFp
int(* SDLTest_TestCaseFp)(void *arg)
Definition: SDL_test_harness.h:67
main_testImpliedJoystickInit
static int main_testImpliedJoystickInit(void *arg)
Definition: testautomation_main.c:75
TEST_ENABLED
#define TEST_ENABLED
Definition: SDL_test_harness.h:47

Definition at line 134 of file testautomation_main.c.

const SDLTest_TestCaseReference mainTest4

static

Initial value:
=
{ (SDLTest_TestCaseFp)main_testImpliedJoystickQuit, "main_testImpliedJoystickQuit", "Tests that quit for gamecontroller doesn't quit joystick if you inited it explicitly", TEST_ENABLED}
SDLTest_TestCaseFp
int(* SDLTest_TestCaseFp)(void *arg)
Definition: SDL_test_harness.h:67
main_testImpliedJoystickQuit
static int main_testImpliedJoystickQuit(void *arg)
Definition: testautomation_main.c:100
TEST_ENABLED
#define TEST_ENABLED
Definition: SDL_test_harness.h:47

Definition at line 137 of file testautomation_main.c.

const SDLTest_TestCaseReference* mainTests[]

static

Initial value:
= {
&mainTest1,
&mainTest2,
&mainTest3,
&mainTest4,
NULL
}
mainTest3
static const SDLTest_TestCaseReference mainTest3
Definition: testautomation_main.c:134
mainTest1
static const SDLTest_TestCaseReference mainTest1
Definition: testautomation_main.c:128
mainTest4
static const SDLTest_TestCaseReference mainTest4
Definition: testautomation_main.c:137
mainTest2
static const SDLTest_TestCaseReference mainTest2
Definition: testautomation_main.c:131
NULL
#define NULL
Definition: begin_code.h:143

Definition at line 141 of file testautomation_main.c.

SDLTest_TestSuiteReference mainTestSuite

Initial value:
= {
"Main",
NULL,
mainTests,
NULL
}
mainTests
static const SDLTest_TestCaseReference * mainTests[]
Definition: testautomation_main.c:141
NULL
#define NULL
Definition: begin_code.h:143

Definition at line 150 of file testautomation_main.c.